/*
 * $Id: hmg-include.ch 0 2011-04-17 00:00:01Z l3wonsf $
 */

/*
 * HMG Source Code
 *
 * Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 * http://sites.google.com/site/hmgweb/
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or( at your option ) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License FOR more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this software; see the file COPYING. IF not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA( or
 * visit the web site http://www.gnu.org/ ).
 *
 * As a special exception, you have permission FOR additional uses of the text
 * contained in this release of HMG.
 *
 * The exception is that, IF you link the HMG library with other
 * files to produce an executable, this does not by itself cause the resulting
 * executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of linking the
 * HMG library code into it.
 */

#ifndef _HMG_CH
 
 #define _HMG_CH

// Window Type
#define WND_STANDARD                              0
#define WND_MAIN                                  1
#define WND_CHILD                                 2
#define WND_PANEL                                 3
#define WND_MODAL                                 4
#define WND_SPLITCHILD                            5

// commands
#xcommand ACTIVATE WINDOW <oObj>               => HmgWindows:<oObj>:Activate()
#xcommand CENTER WINDOW <oObj>                 => HmgWindows:<oObj>:Center()
#xcommand CAPTION <cValue>                     => :Caption             := <cValue>
#xcommand COL <nValue>                         => :Col                 := <nValue>
#xcommand DEFINE BUTTON <oObj>[, <oParent>]    => WITH OBJECT HMGBUTTON():New( <"oObj">, <oParent> )
#xcommand DEFINE WINDOW <oObj>[, <oParent>]    => __MVPUBLIC ( <"oObj"> ); WITH OBJECT <oObj> := HMGWINDOW():New( <"oObj">, <oParent> )
#xcommand END BUTTON                           => END WITH
#xcommand END WINDOW                           => :EndWindow() ; END WITH
#xcommand FLAT <lValue>                        => :Flat                := <lValue>
#xcommand FONTSIZE <nValue>                    => :FontSize            := <nValue>
#xcommand HEIGHT <nValue>                      => :Height              := <nValue>
#xcommand ICON <cValue>                        => :Icon                := <cValue>
#xcommand ONAFTERSHOW <bValue>                 => :OnAfterShow         := {|| <bValue> }
#xcommand ONCLICK <bValue>                     => :OnMouseClick        := {|| <bValue> }
#xcommand ONINIT <bValue>                      => :OnInit              := {|| <bValue> }
#xcommand ONRELEASE <bValue>                   => :OnRelease           := {|| <bValue> }
#xcommand PICTURE <cValue>                     => :Icon                := <cValue>
#xcommand ROW <nValue>                         => :Row                 := <nValue>
#xcommand SET RESOURCE TO <cValue>             => HMGRESOURCE():RegisterResource( <cValue> )
#xcommand TITLE <cValue>                       => :Title               := <cValue>
#xcommand WIDTH <nValue>                       => :Width               := <nValue>
#xcommand WINDOWTYPE MAIN                      => :FormType            := WND_MAIN
#xcommand WINDOWTYPE STANDARD                  => :FormType            := WND_STANDARD
#xcommand WINDOWTYPE MODAL                     => :FormType            := WND_MODAL

#endif /* _HMG_CH */

// at this moment, current HbQt release don't have mapped these values.
#define QPalette_Disabled	                       1
#define QPalette_Active	                          0
#define QPalette_Inactive	                       2
#define QPalette_Normal	                          QPalette_Active       // synonym for Active

#define QValidator_Invalid        0    // The string is clearly invalid.
#define QValidator_Intermediate   1    // The string is a plausible intermediate value.
#define QValidator_Acceptable     2    // The string is acceptable as a final result; i.e. it is valid.

MEMVAR HmgWindows
