/*
 * $Id: hmg-application.prg 0 2011-04-17 00:00:01Z l3wonsf $
 */

/*
 * HMG Source Code
 *
 * Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 * http://sites.google.com/site/hmgweb/
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or( at your option ) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License FOR more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this software; see the file COPYING. IF not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA( or
 * visit the web site http://www.gnu.org/ ).
 *
 * As a special exception, you have permission FOR additional uses of the text
 * contained in this release of HMG.
 *
 * The exception is that, IF you link the HMG library with other
 * files to produce an executable, this does not by itself cause the resulting
 * executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of linking the
 * HMG library code into it.
 */

#include "hmg-include.ch"

/*==============================================================================
 HMGAPPLICATION function
 =============================================================================*/

PROCEDURE HMGStart()

 IF !__mvEXIST( "HmgWindows" )
  __mvPUBLIC( "HmgWindows" )
 ENDIF

 HmgWindows := HMGAPPLICATION():New()

RETURN

#include "hbqtgui.ch"
#include "hbclass.ch"
#include "common.ch"
/*==============================================================================
 HMGAPPLICATION class
 =============================================================================*/
CLASS HMGAPPLICATION FROM HMGSHARED, HMGPARENT

// Methods
   METHOD New
   METHOD Quit
   METHOD Start

// Properties

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:New()

   ::cName          := "HmgWindows"
   
   ::Start()

RETURN Self

/*---------------------------------------------------------------
 Start
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:Start()

   LOCAL cPath, cFile, cExt
   LOCAL QtPluginPath

   hb_FnameSplit( hb_Progname(), @cPath, @cFile, @cExt )

// in this way you can put plugins dll in <ExePath>\Qt\Plugins and Qt try to find here and qt.conf it's not required
// ie <ExePath>\Qt\Plugins\ImageFormats\qico4.dll
// TODO take this as a parameter
   QtPluginPath := cPath + "Qt" + hb_ps() + "plugins"


   IF ::lQtStarted == .F.
      ::lQtStarted     := .T.
      ::sQtApplication := QApplication()
      ::sQtResource    := QResource()
      ::sQtLocale      := QLocale()
// to get path list use :libraryPaths()
      ::sQtApplication:addLibraryPath( QtPluginPath )
      ::oSuperParent   := Self
      ::oQtObject      := ::sQtApplication:DeskTop()
      HMGRESOURCE():RegisterResource( cFile )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Quit
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:Quit()

   IF ::lQtStarted == .T.
      HMGRESOURCE():UnRegisterResources()
      ::sQtApplication:Exit()
      ::sQtApplication:Quit()
      IF __mvEXIST( "HmgWindows" )
         __mvXRELEASE( "HmgWindows" )
      ENDIF
   ENDIF

RETURN NIL

/*................................................................
 Properties - section
 ................................................................*/
